



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>2.1、Android Studio通过Lint提升你的代码</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">2.1、Android Studio通过Lint提升你的代码</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 13:18:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>为了测试你的Android应用符合功能需求。最重要的是确保你的代码没有结构性问题。结构差的代码影响你的Android应用的可靠性，让你的代码难以维护。比如，如果你的XML资源文件包含未使用的明明空间，这会花费空间和不必要的进程。其他机构行问题，比如是哟个过时的API调用，如果设备API版本不兼容，可能导致运行失败。</p>
<h1>概览</h1>
<p>Android Studio提供了一个称为Lint的代码扫描工具，可以非常容易的帮你辨别和纠正代码的结构性质量问题，而无须你执行app或者编写测试用例。工具检测到的每个错误都会标明严重程度一个描述信息，这样你就可以迅速的确定优先级。你也可以将在你项目中无关紧要的错误进行忽略。这个工具有相应的命令行接口，所以你可以非常容易的整合到你的测试进程中。 <br /><br />
Lint工具通过检测你的Android项目源代码来发现潜在的bug并提供代码优化建议。你可以从命令行或者Android Studio中运行Lint。 <br /><br />
 <img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160621134733521"></p>
<h2>Application 源文件（Application source files）</h2>
<p>源文件包含组成你的Android项目的文件，包含Java和XML文件、图标和ProGuard配置文件。</p>
<h2>Lint.xml文件</h2>
<p>配置文件，用于配置你想忽略的问题，或者更高问题的严重级别。</p>
<h2>Lint工具</h2>
<p>你可以通过命令行或者Android Studio运行在你的Android项目上的静态代码扫描工具。Lint工具检测影响你的Android应用的质量和性能的代码结构性问题。强烈建议在发布你的应用之前修复Lint检测到的任何问题</p>
<h2>Lint检测结果</h2>
<p>你可以在Android Studio的Event Log中来查看Lint的结果（或者在命令行中）。 <br /><br />
Lint工具作为Android SDK工具的一部分（&gt;=16）。</p>
<h1>在Android Studio中运行Lint</h1>
<p>在Android Studio中，当你构建你的app时，Lint自动运行。 <br /><br />
在Android Studio中你可以在android设置中添加lintOptions属性。如下：</p>
<pre class="prettyprint linenums"><code>android {<br />
    lintOptions {<br />
       // 设置为true会关闭lint分析进度<br />
       quiet true<br />
       // 如果为true，则在发现错误时停止gradle构建<br />
       abortOnError false<br />
       // 如果为true，则只报告错误<br />
       ignoreWarnings true<br />
       }<br />
}</code></pre>
<h1>命令行运行Lint</h1>
<p>运行lint检测项目：</p>
<pre class="prettyprint linenums"><code>lint [flags] &lt;project directory&gt;</code></pre>
<p>检测项目的某个错误，以下这个用于检测Android命名空间前缀：</p>
<pre class="prettyprint linenums"><code>lint --check MissingPrefix myproject</code></pre>
<p>查看lint帮助，可用：</p>
<h1>Lint输出示例</h1>
<p>接下来展示lint检测一个Earthquake的项目输出的信息：</p>
<pre class="prettyprint linenums"><code>$ lint Earthquake

Scanning Earthquake: ...............................................................................................................................<br />
Scanning Earthquake (Phase 2): .......<br />
AndroidManifest.xml:23: Warning: &lt;uses-sdk&gt; tag appears after &lt;application&gt; tag [ManifestOrder]<br />
  &lt;uses-sdk android:minSdkVersion="7" /&gt;<br />
  ^<br />
AndroidManifest.xml:23: Warning: &lt;uses-sdk&gt; tag should specify a target API level (the highest verified version; when running on later versions, compatibility behaviors may be enabled) with android:targetSdkVersion="?" [UsesMinSdkAttributes]<br />
  &lt;uses-sdk android:minSdkVersion="7" /&gt;<br />
  ^<br />
res/layout/preferences.xml: Warning: The resource R.layout.preferences appears to be unused [UnusedResources]<br />
res: Warning: Missing density variation folders in res: drawable-xhdpi [IconMissingDensityFolder]<br />
0 errors, 4 warnings</code></pre>
<h1>配置lint</h1>
<p>默认情况下，当你运行一个扫描的时候，会检测Lint支持的所有的issue。你可以禁止Lint检测某个issue或者设置issue的安全级别。 <br /><br />
你可以在不同级别来配置Lint检测： <br /><br />
1、  全局，针对整个项目 <br /><br />
2、  每个项目模块 <br /><br />
3、  每个测试模块 <br /><br />
等等。</p>
<h1>在Android Studio中配置Lint</h1>
<p>当你使用Android Studio时，内置的Lint工具可以检测你的代码。你可以通过两种方式来查看警告和错误： <br /><br />
1、  代码编辑器中，当Lint发现错误之后，会黄色高翔显示问题代码。 <br /><br />
2、  选择Analyze &gt; Inspect Code，打开Lint Inspection Results。</p>
<h1>设置默认Lint检测：</h1>
<p>1、  在Android Studio中，打开你的项目。 <br /><br />
2、  选择File &gt; Other Settings &gt; Default Settings <br /><br />
3、  选择Editor &gt; Inspections，打开Default Preferences对话框。 <br /><br />
4、  在Profile中，选择Default或者Project Default。 <br /><br />
5、  根据需要更改Lint设置。 <br /><br />
6、  点击OK。</p>
<h1>将Lint检测显示在Inspection Results窗口：</h1>
<p>1、  在Android Studio中，打开项目，选择你要测试的部分 <br /><br />
2、  选择Analyze &gt; Inspect Code <br /><br />
3、  在Specify Inspection Scope对话框中，选择需要测试的部分 <br /><br />
4、  点击OK。 <br /><br />
结构将根据分类显示在Inspection Results窗口。</p>
<h1>配置Lint文件</h1>
<p>你可以在lint.xml文件中声明Lint检测参数。如果你手动创建这个文件，将它放在你的Android项目的根目录。如果你在Android Studio中配置你的Lint参数，lint.xml自动生成并添加到你的项目中。 <br /><br />
Lint.xml 文件包含一个父标签，包含一个或多个标签。如下：</p>
<pre class="prettyprint linenums"><code>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
    &lt;lint&gt;<br />
        &lt;!-- list of issues to configure --&gt;<br />
&lt;/lint&gt;</code></pre>
<p>通过设置标签，你可以禁用Lint检测某个issue或者更高某个issue的级别。 <br /><br />
注意：查看lint支持的issue列表，可以运行lint –list命令 <br /><br />
Lint.xml文件示例 <br /><br />
下面是一个lint.xml文件示例：</p>
<pre class="prettyprint linenums"><code>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;lint&gt;<br />
    &lt;!-- Disable the given check in this project --&gt;<br />
    &lt;issue id="IconMissingDensityFolder" severity="ignore" /&gt;

    &lt;!-- Ignore the ObsoleteLayoutParam issue in the specified files --&gt;<br />
    &lt;issue id="ObsoleteLayoutParam"&gt;<br />
        &lt;ignore path="res/layout/activation.xml" /&gt;<br />
        &lt;ignore path="res/layout-xlarge/activation.xml" /&gt;<br />
    &lt;/issue&gt;

    &lt;!-- Ignore the UselessLeaf issue in the specified file --&gt;<br />
    &lt;issue id="UselessLeaf"&gt;<br />
        &lt;ignore path="res/layout/main.xml" /&gt;<br />
    &lt;/issue&gt;

    &lt;!-- Change the severity of hardcoded strings to "error" --&gt;<br />
    &lt;issue id="HardcodedText" severity="error" /&gt;<br />
&lt;/lint&gt;</code></pre>
<h1>在Java和XML源文件中配置lint检测</h1>
<p>你可以在Java和XML文件中禁用Lint检测</p>
<h2>在Java中配置lint检测</h2>
<p>为了在你的Android项目中指定的类或方法中金庸Lint检测，在Java代码中添加@SupprewwLint注解。</p>
<p>接下来的示例显示在OnCreate方法中如何关闭Lint检测，Lint工具在其他方法中继续检测NewApi issue。</p>
<pre class="prettyprint linenums"><code>@SuppressLint("NewApi")<br />
@Override<br />
public void onCreate(Bundle savedInstanceState) {<br />
    super.onCreate(savedInstanceState);<br />
setContentView(R.layout.main);</code></pre>
<p>下面的示例显示如何关闭ParserError issue：</p>
<pre class="prettyprint linenums"><code>@SuppressLint("ParserError")<br />
public class FeedProvider extends ContentProvider {}</code></pre>
<p>在Java文件中禁止所有Lint检测，如下：</p>
<pre class="prettyprint linenums"><code>@SuppressLint("all")</code></pre>
<h2>在XML中配置Lint检测</h2>
<p>在XML文件中，你可以使用tools：ignore属性来金庸Lint检测。为了使相关属性被Lint工具识别，必须添加如下命名空间到你的XML文namespace xmlns:tools=<a href="http://schemas.android.com/tools" rel="external nofollow noreferrer">http://schemas.android.com/tools</a>下：</p>
<pre class="prettyprint linenums"><code>&lt;LinearLayout<br />
    xmlns:android="http://schemas.android.com/apk/res/android"<br />
    xmlns:tools="http://schemas.android.com/tools"<br />
    tools:ignore="UnusedResources" &gt;

    &lt;TextView<br />
        android:text="@string/auto_update_prompt" /&gt;<br />
&lt;/LinearLayout&gt;</code></pre>
<p>禁用多个issue，如下：</p>
<pre class="prettyprint linenums"><code>tools:ignore="NewApi,StringFormatInvalid"</code></pre>
<p>禁用所有的issue 检测，如下：</p>
<pre class="prettyprint linenums"><code>tools:ignore="all"</code></pre>
<p>本文作者：宋志辉  <br /><br />
个人微博：<a href="http://weibo.com/askzhihui/" rel="external nofollow noreferrer">点击进入</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q71kgjq.html">JuQueen&lpar;线段树 lazy&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvervxq.html">后缀为inc的是什么文件？C&num;中如何包含inc文件？</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xmg2z8.html">linux 下查看系统内存使用情况的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd0w2jq.html">Ubuntu 14&period;04 启用休眠</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde3d4v9.html">【CF521C】【排列组合】Pluses everywhere</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmvglz9.html">hdu 4322 最大费用流</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5j4gq.html">&lbrack;Redux&rsqb; Avoiding Object Mutations with Object&period;assign&lpar;&rpar; and &period;&period;&period;spread</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vor338.html">springMVC在JSP页面取map值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdm03k9.html">HTTP  中  POST和GET的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j26l38.html">struts2&period;1&period;6教程九、文件上传下载（了解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m1do48.html">android项目 之 记事本（11） ----- 加入数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yrwkw8.html">压力测试（webbench、ab、siege）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd4n249.html">c&num; 编程语言tag</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv14oroq.html">PBRT笔记&lpar;7&rpar;&mdash;&mdash;反射模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojx5v1q.html">网络编程之socketserver以及socket更多方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdlzxv9.html">&commat;Html自定义属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyrjgdq.html">JSP中三大指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjdl6e9.html">c&num;中的委託，匿名方法和lambda表達式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o0ee18.html">java应用健康检查</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7w6zq.html">Mysql 提升大数据表的拷贝效率</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7z1mex9.html">51nod 1204 Parity&lpar;并查集应用&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me4nprq.html">Codeforces Round &num;407 &lpar;Div&period; 1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m52x48.html">java线程池的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkgl7v8.html">CNN中的经典结构之AlexNet</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyk53m9.html">session&period;save&lpar;&rpar;返回值问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z1nlk9.html">Python小代码&lowbar;11&lowbar;生成小于 n 的裴波那契数列</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy13regq.html">Luogu P3740 &lbrack;HAOI2014&rsqb;贴海报&lowbar;线段树</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me4wd2q.html">关于mysql安装到最后一步老是停留在starting server，显示无响应</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjeyd28.html">项目实战15&period;2&mdash;企业级堡垒机 jumpserver快速入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pnyd38.html">Vue nextTick 机制</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
